﻿Public Class GameInputClass

    Public IsUp As Boolean
    Public IsDown As Boolean
    Public IsLeft As Boolean
    Public IsRight As Boolean

    Public Is1 As Boolean
    Public Is2 As Boolean
    Public Is3 As Boolean
    Public Is4 As Boolean
    Public Is5 As Boolean
    Public Is6 As Boolean
    Public Is7 As Boolean
    Public Is8 As Boolean
    Public Is9 As Boolean
    Public Is0 As Boolean

    Public IsESC As Boolean
    Public IsSpace As Boolean
    Public IsEnter As Boolean
    Public IsControl As Boolean

    Public IsP As Boolean
    Public IsA As Boolean
    Public IsS As Boolean
    Public IsD As Boolean
    Public IsF As Boolean
    Public IsG As Boolean
    Public IsH As Boolean
    Public IsQ As Boolean
    Public IsY As Boolean
    Public IsU As Boolean
    Public IsI As Boolean
    Public IsO As Boolean
    Public IsW As Boolean
    Public IsZ As Boolean

    Public OldRight As Boolean
    Public OldUp As Boolean
    Public OldDown As Boolean
    Public OldLeft As Boolean

    Public Old1 As Boolean
    Public Old2 As Boolean
    Public Old3 As Boolean
    Public Old4 As Boolean
    Public Old5 As Boolean
    Public Old6 As Boolean
    Public Old7 As Boolean
    Public Old8 As Boolean
    Public Old9 As Boolean
    Public Old0 As Boolean

    Public OldEsc As Boolean
    Public OldSpace As Boolean
    Public OldEnter As Boolean
    Public OldControl As Boolean

    Public OldP As Boolean
    Public oldA As Boolean
    Public oldS As Boolean
    Public oldD As Boolean
    Public oldF As Boolean
    Public OldG As Boolean
    Public OldH As Boolean
    Public OldQ As Boolean
    Public OldY As Boolean
    Public OldU As Boolean
    Public OldI As Boolean
    Public OldO As Boolean
    Public OldW As Boolean
    Public OldZ As Boolean

    ' this function is used to set the control manually from the keyboard
    Public Sub UpdateControlInputStatusFromKeyboard()
        ' update old keys
        OldSpace = IsSpace

        OldUp = IsUp
        OldDown = IsDown
        OldLeft = IsLeft
        OldRight = IsRight

        Old1 = Is1
        Old2 = Is2
        Old3 = Is3
        Old4 = Is4
        Old5 = Is5
        Old6 = Is6
        Old7 = Is7
        Old8 = Is8
        Old9 = Is9
        Old0 = Is0

        OldEnter = IsEnter
        OldEsc = IsESC
        OldControl = IsControl

        OldP = IsP
        oldA = IsA
        oldS = IsS
        oldD = IsD
        oldF = IsF
        OldG = IsG
        OldH = IsH
        OldQ = IsQ
        OldY = IsY
        OldU = IsU
        OldI = IsI
        OldO = IsO
        OldW = IsW
        OldZ = IsZ

        ' update the current ones

        IsUp = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Up)
        IsDown = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Down)
        IsLeft = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Left)
        IsRight = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Right)

        Is1 = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D1)
        Is2 = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D2)
        Is3 = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D3)
        Is4 = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D4)
        Is5 = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D5)
        Is6 = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D6)
        Is7 = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D7)
        Is8 = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D8)
        Is9 = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D9)
        Is0 = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D0)

        IsESC = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Escape)
        IsEnter = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Enter)
        IsSpace = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Space)
        IsControl = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Control)

        IsP = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.P)
        IsA = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.A)
        IsS = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.S)
        IsD = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D)
        IsF = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F)
        IsG = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.G)
        IsH = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.H)
        IsQ = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Q)
        IsY = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Y)
        IsU = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.U)
        IsI = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.I)
        IsO = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.O)
        IsW = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.W)
        IsZ = AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Z)
    End Sub

    ' this function is used to reset all keyboard keys
    Public Sub ResetAllKeyboardKeyState()

        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.A) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Alt) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.B) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.BackSlash) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.BackSpace) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.BrowserBack) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.BrowserFavorites) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.BrowserForward) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.BrowserHome) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.BrowserRefresh) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.BrowserSearch) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.BrowserStop) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.C) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.CapsLock) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Clear) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.CloseBracket) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Comma) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Control) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.ControlLeft) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.ControlRight) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D0) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D1) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D2) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D3) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D4) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D5) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D6) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D7) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D8) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.D9) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Delete) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Down) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.E) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.End) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Enter) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Escape) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Execute) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F1) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F10) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F11) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F12) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F13) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F14) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F15) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F16) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F17) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F18) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F19) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F20) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F2) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F21) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F22) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F23) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F24) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F3) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F4) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F5) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F6) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F7) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F8) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.F9) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.G) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.H) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Help) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Home) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.I) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Insert) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.J) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.K) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.L) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.LaunchApplication1) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.LaunchApplication2) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.LaunchMail) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.LineFeed) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Left) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.M) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.MediaNextTrack) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.MediaPlayPause) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.MediaPreviousTrack) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.MediaStop) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Menu) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Minus) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.N) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.None) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.NumLock) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.NumPad0) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.NumPad1) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.NumPad2) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.NumPad3) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.NumPad4) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.NumPad5) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.NumPad6) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.NumPad7) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.NumPad8) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.NumPad9) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.NumPadMinus) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.NumPadMultiply) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.NumPadPeriod) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.NumPadPlus) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.NumPadSlash) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.O) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.OpenBracket) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.P) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.PageDown) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.PageUp) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Pause) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Period) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Plus) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Print) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.PrintScreen) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Q) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Quotes) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.R) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Return) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Right) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.S) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.ScrollLock) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Select) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.SelectMedia) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Semicolon) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Separator) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Shift) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.ShiftLeft) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.ShiftRight) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Slash) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Sleep) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Space) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.T) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Tab) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Tilde) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.U) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Up) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.V) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.VolumeDown) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.VolumeMute) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.VolumeUp) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.W) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.WinLeft) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.WinRight) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.X) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Y) = False
        AgateLib.InputLib.Keyboard.Keys(AgateLib.InputLib.KeyCode.Z) = False
    End Sub

End Class
