﻿Public Class MainForm

 


    Private Sub RunGame(ByVal fullscreen As Boolean, ByVal WinWidth As Long, ByVal WinHeight As Long)
        If Not GeneralOperations.InitializeAgateLib Then
            MsgBox("Error")
            End
        End If



        If Not InitializeGlobalGameObjects(fullscreen, WinWidth, WinHeight) Then
            MsgBox("Error")
            End
        End If



        GameMapObject.CreateBrickShapes()

        GameDisplayObject.EyeX = 0
        GameDisplayObject.EyeY = 0

        Dim CMD As String = RenderWelcomeScreen()
        If CMD = "End" Then
            End
        End If
        If CMD = "1" Then
            MsgBox("This option is not implemented yet", MsgBoxStyle.OkOnly Or MsgBoxStyle.Critical, "Error")
            Exit Sub
        End If


        End
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click

        'Try


        Dim FullScreen As Boolean
        Dim WindowWidth As Long
        Dim WindowHeight As Long

        If ComboBox1.Text.Contains("Fullscreen") Then
            FullScreen = True
        Else
            FullScreen = False
        End If

        If FullScreen Then
            MsgBox("The map can not be accessed in fullscreen mode", MsgBoxStyle.OkOnly, "Error")
            Exit Sub
        End If

        WindowWidth = ComboBox1.Text.Split(" ")(0).Split("x")(0)
        WindowHeight = ComboBox1.Text.Split(" ")(0).Split("x")(1)



        If Not GeneralOperations.InitializeAgateLib Then
            MsgBox("Error")
            End
        End If




        If Not InitializeGlobalGameObjects(FullScreen, WindowWidth, WindowHeight) Then
            MsgBox("Error")
            End
        End If

        If TextBox1.Text = "" Then
            Dim Width As Integer = InputBox("Enter Map width")
            Dim Height As Integer = InputBox("Enter Map height")
            GameMapObject.CreateEmptyMap(Width, Height)
        Else
            GameCreaturesObject.UserCharacter1 = New Hero
            GameCreaturesObject.AllCreatureList = New List(Of BaseCreature)
            GameCreaturesObject.BoxList = New List(Of Box)
            GameMapObject.LoadMap(TextBox1.Text, False)
        End If

        GameMapObject.CreateBrickShapes()
        GameDisplayObject.EyeX = 0
        GameDisplayObject.EyeY = 0

        RenderingMapSub()
        'Catch ex As Exception
        '    MsgBox("Error while running the game" & vbNewLine & ex.Message, MsgBoxStyle.OkOnly Or MsgBoxStyle.Critical, "Error")
        '    End
        'End Try

    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Dim OFD As New OpenFileDialog
        OFD.Filter = "*.map|*.map"
        OFD.ShowDialog()
        TextBox1.Text = OFD.FileName
    End Sub

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ComboBox1.Text = "800x600 Window"
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        'Try

        Dim FullScreen As Boolean
        Dim WindowWidth As Long
        Dim WindowHeight As Long

        If ComboBox1.Text.Contains("Fullscreen") Then
            FullScreen = True
        Else
            FullScreen = False
        End If
        WindowWidth = ComboBox1.Text.Split(" ")(0).Split("x")(0)
        WindowHeight = ComboBox1.Text.Split(" ")(0).Split("x")(1)

        RunGame(FullScreen, WindowWidth, WindowHeight)
        'Catch ex As Exception
        '    MsgBox("Error while running game" & vbNewLine & ex.Message, MsgBoxStyle.OkOnly Or MsgBoxStyle.Critical, "Error")
        'End Try
        End
    End Sub


End Class
