﻿Public Class GameSpritesClass

    Public HeroSprite As AgateLib.Sprites.Sprite
    Public HeroineSprite As AgateLib.Sprites.Sprite
    Public DynamiteSprite As AgateLib.Sprites.Sprite
    Public EmptyBoxSprite As AgateLib.Sprites.Sprite
    Public DynamiteBoxSprite As AgateLib.Sprites.Sprite
    Public ShoeBoxSprite As AgateLib.Sprites.Sprite
    Public HealthBoxSprite As AgateLib.Sprites.Sprite
    Public GloveBoxSprite As AgateLib.Sprites.Sprite
    Public BombBoxSprite As AgateLib.Sprites.Sprite
    Public IgnitedBombSprite As AgateLib.Sprites.Sprite
    Public IgnitedDynamiteSprite As AgateLib.Sprites.Sprite
    Public PresistantEnemySprite As AgateLib.Sprites.Sprite
    Public StupidEnemySprite As AgateLib.Sprites.Sprite
    Public MonkeySprite As AgateLib.Sprites.Sprite
    Public SmokeSprite As AgateLib.Sprites.Sprite
    Public InfoSprite As AgateLib.Sprites.Sprite
    Public SpiderSprite As AgateLib.Sprites.Sprite
    Public OnOffButtonSprite As AgateLib.Sprites.Sprite
    Public ArrowSOurceRightSprite As AgateLib.Sprites.Sprite
    Public GateSprite As AgateLib.Sprites.Sprite
    Public ActionSprite As AgateLib.Sprites.Sprite
    Public TeleportSprite As AgateLib.Sprites.Sprite
    Public BatSprite As AgateLib.Sprites.Sprite
    Public PushButtonSprite As AgateLib.Sprites.Sprite
    Public WolfmanSprite As AgateLib.Sprites.Sprite
    Public Gate2Sprite As AgateLib.Sprites.Sprite
    Public ArrowButtonSprite As AgateLib.Sprites.Sprite
    Public ArrowLeftSprite As AgateLib.Sprites.Sprite
    Public ArrowRightSprite As AgateLib.Sprites.Sprite
    Public ArrowDownSprite As AgateLib.Sprites.Sprite
    Public ArrowUpSprite As AgateLib.Sprites.Sprite
    Public ArrowSourceUpSprite As AgateLib.Sprites.Sprite
    Public ArrowSourceDownSprite As AgateLib.Sprites.Sprite
    Public ArrowSourceLeftSprite As AgateLib.Sprites.Sprite
    Public AxeRightSprite As AgateLib.Sprites.Sprite
    Public AxeLeftSprite As AgateLib.Sprites.Sprite
    Public HeroAxeSprite As AgateLib.Sprites.Sprite
    Public HeroineAxeSprite As AgateLib.Sprites.Sprite
    Public AxeBoxSprite As AgateLib.Sprites.Sprite

    ' load all sprites
    Public Function LoadAllSprites() As Boolean
        'Try
        DynamiteBoxSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\boxdynamite.png", 16, 16)
        EmptyBoxSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\boxempty.png", 16, 16)
        ShoeBoxSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\boxshoe.png", 16, 16)
        HealthBoxSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\boxhealth.png", 16, 16)
        GloveBoxSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\boxglove.png", 16, 16)
        BombBoxSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\boxbomb.png", 16, 16)
        HeroSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\hero.png", 22, 32)
        IgnitedBombSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\bombignited.png", 16, 16)
        IgnitedDynamiteSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\dynamiteignited.png", 16, 16)
        PresistantEnemySprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\e2.png", 25, 32)
        StupidEnemySprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\e1.png", 25, 32)
        MonkeySprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\monkey.png", 33, 26)
        SmokeSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\smoke.png", 16, 16)
        InfoSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\info.png", 16, 16)
        SpiderSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\spider.png", 40, 34)
        OnOffButtonSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\onoffbutton.png", 27, 15)
        GateSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\gate.png", 64, 64)
        ActionSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\action.png", 16, 16)
        WolfmanSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\wolfman.png", 32, 32)
        TeleportSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\teleport.png", 16, 16)
        BatSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\bat.png", 16 * 3, 16 * 2)
        HeroineSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\heroine.png", 22, 32)
        PushButtonSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\pushbutton.png", 16, 16)
        Gate2Sprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\gate2.png", 64, 64)
        ArrowButtonSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\arrowbutton.png", 16, 16)
        ArrowRightSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\arrowright.png", 32, 16)
        ArrowLeftSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\arrowleft.png", 32, 16)
        ArrowUpSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\arrowup.png", 16, 32)
        ArrowDownSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\arrowdown.png", 16, 32)
        ArrowSourceUpSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\arrowsourceup.png", 16, 16)
        ArrowSourceDownSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\arrowsourcedown.png", 16, 16)
        ArrowSourceLeftSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\arrowsourceleft.png", 16, 16)
        ArrowSOurceRightSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\arrowsourceright.png", 16, 16)
        AxeRightSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\axeright.png", 32, 32)
        AxeLeftSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\axeleft.png", 32, 32)
        HeroAxeSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\HeroAxe.png", 32, 32)
        HeroineAxeSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\HeroineAxe.png", 32, 32)
        AxeBoxSprite = New AgateLib.Sprites.Sprite(Application.StartupPath & "\images\boxaxe.png", 16, 16)

        Return True
        'Catch ex As Exception
        '    Return False
        'End Try
    End Function


End Class
